"""
One of the types of content is the Form component.

This module produce the HTML for Tier and Statistical Plots.
"""

import PlotContents 

def PlotForm(plotContent):
  form=""" <form name="%sForm" action="" method="GET"><fieldset>
            <legend>Plot options:</legend>"""%plotContent.name
  for i in plotContent.parameters:
    form+=i.getFormOptions()
  form+="""<BR/> <div align="center">
         <input type="button" value="Update Plot(s)" onClick="javascript:processForm('%s')" /> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
         <input type="button" value="Reset to Default Plot(s)" onClick="javascript:processForm('%s','True')" /></div>
        </fieldset></form>"""%(plotContent.name,plotContent.name)
  return form
################################################################3

def TierAllForm(config,kwargs):
  """
  Form for the page Tier Plot. This form controls the whole page. 
  """
  #dummy used only to read Tier Plot Parameters
  dummyContent= PlotContents.TierPlotsContent(config,kwargs)
  form=""" <form name="TierAllForm" action="" method="GET"><fieldset>
            <legend>All Tier Plot options:</legend>"""
  for i in dummyContent.parameters:
    form+=i.getFormOptions()
  form+="""<BR/> <div align="center">
         <input type="button" value="Update Plot(s)" onClick="javascript:processForm('TierAll')" /> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
         <input type="button" value="Reset to Default Plot(s)" onClick="javascript:processForm('TierAll','True')" /></div>
        </fieldset></form>"""
  return form

def StatAllForm(config,kwargs):
  """
  Form for the page Statistical Plot. This form controls the whole page.
  """
  #dummy content used only to read Stat Plot Parameters
  dummyContent= PlotContents.StatPlotContent(config,kwargs)
  form=""" <form name="StatAllForm" action="statPlots.html" method="GET"><fieldset>
            <legend>Plot options:</legend>"""
  for i in dummyContent.parameters:
    form+=i.getFormOptions()
  form+="""<BR/> <div align="center">
         <input type="button" value="Update Plot(s)" onClick="javascript:processForm('StatAll')" /> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
         <input type="button" value="Reset to Default Plot(s)" onClick="javascript:processForm('StatAll','True')" /></div>
        </fieldset></form>"""
  return form