import os,time,re,cherrypy,smtplib,socket
from DASManager import DASCall
 
ALARM_FLAG="T0Mon-alarm-%s"
ALARM_INTERVAL=3600 # seconds between 2 different mail alarms are sent
TMP_DIR="var/"


MAIL_MESSAGE="""From: T0Mon<T0Mon-service@cern.ch>
To: %s <%s>
Subject: T0Mon error

T0Mon URL= %s
DAS   URL= %s
 
%s
""" 

def sendAlarm(config,errorMessage=""):
  """
   this method sends an errorMessage to the service Administrator
  """
  receiver=config.emailAlert
  port=cherrypy.config['server.socket_port']
  # the alarm may be sent to different addresses: I need a flag for any of them
  ALARM_FILE=ALARM_FLAG%(str(receiver))
  if (existsFile(ALARM_FILE)):
    if fileOlderThan(ALARM_FILE, ALARM_INTERVAL):
      removeFile(ALARM_FILE) 
  if not(existsFile(ALARM_FILE)):
    sender = 'T0Mon-service@cern.ch'
    #receiver=self.config.emailAlert
    print "T0Mon: Sending mail to: "+str(receiver)
    message = MAIL_MESSAGE
    message=message%(receiver,receiver,"http://"+socket.gethostname()+":"+str(port)+"/",config.DASUrl,errorMessage)
    try:
      smtpObj = smtplib.SMTP('localhost')
      smtpObj.sendmail(sender, receiver, message)
      setFlag(ALARM_FILE)  
      print("T0Mon:Successfully sent email")
    except Exception:
      print("T0Mon:Error: unable to send email")
#######################################################################
def  testDAS(config):
  """
   This method is used to test if DAS is alive
  """
  try:
    call = DASCall(config,'lastruns')
    call.start()
    call.join()    
    return call.status==0
  except:
    return False
##################################################################### Configuration options check
def configurationCheck(confDict):
  """
  This method check the configuration file has the mandatory options
  """
  log=""
  DAS=""
  ## cehcking DAS url
  try:
    DAS=confDict['DAS']
  except  KeyError, e:
    log+="T0Mon Configuration Error:  DAS URL missing \n"
  ## checking mail address
  try:
    email=confDict['emailAlert']
    if re.match("^[a-zA-Z0-9._%-]+@cern.ch", email)==None:
      raise KeyError
  except  KeyError, e:
    log+="T0Mon Configuration Error:  mail alert missing or not accepted \n"
  ## checking plotfairy url
  try:
    st=confDict['plotfairy']
  except  KeyError, e:
    log+="T0Mon Configuration Error: PlotFairy url missing \n"
  if len(log)>0:
    return False,log
  return True,log
##################################################### filesystem opeartions
            
def fileOlderThan(file, time):
  try:
    statinfo = os.stat(TMP_DIR+file)
    ftime=  statinfo.st_mtime
    with open(TMP_DIR+TMP_FILE, 'w') as f:
      f.write("1")
    f.close()
    statinfo = os.stat(TMP_DIR+TMP_FILE)
    os.remove(TMP_DIR+TMP_FILE)
    #print "difference file timestamps: %f  timeout=%f on %s"%(statinfo.st_mtime-ftime,time,str(file))
    if statinfo.st_mtime-ftime>=time:
       #print "file: "+str(TMP_DIR+file)+ " older then "+str(time)
       return True
  except: 
     return False
  return False
          
#def getCachedFile(file=CACHE_FILE):
  ## ONLY files in var/ are accessable (if file has a path component I drop it)
  #(head,tail)=os.path.split(file)
  #if not os.path.exists(TMP_DIR+tail):
      ##print "*********************file not found: "+str(file)
      #return "Wrong file or resource not availabe!"
  #with open(TMP_DIR+tail, 'r') as f:
         #read_data = f.read()
  #if file.endswith('.png'): 
     ## I don't know why I have to do t this way, but it is the only way to make it work
     #cherrypy.response.headers['Content-Type']= "image/png"
     #cherrypy.response.body=read_data
     #return  cherrypy.response.body
  #return read_data 
    
def existsFile(file):
   # ONLY files in var/ are accessable (if file has a path component I drop it)
  (head,tail)=os.path.split(file)
  return os.path.exists(TMP_DIR+tail)
    


def setFlag(file):
  (head,tail)=os.path.split(file)
  with open(TMP_DIR+tail, 'w') as f:
    f.write("1")
        
                   
def removeFile(file):
   # ONLY files in var/ are accessable (if file has a path component I drop it)
   (head,tail)=os.path.split(file)
   if not os.path.exists(TMP_DIR+tail):
      return "Wrong file"
   #print "Removing file: " +str(TMP_DIR+file)
   try:
      os.remove(TMP_DIR+file)
   except:
      print "File not found"
      